When attempting to unparse a principal structure containing no components,
the KDC can be made to modify the byte located immediately before a buffer,
corrupting its heap.

--- krb5/src/lib/krb5/krb/unparse.c	2003-03-06 16:45:41.000000000 -0500
+++ krb5/src/lib/krb5/krb/unparse.c	2003-03-06 16:45:31.000000000 -0500
@@ -150,8 +150,10 @@
 		*q++ = COMPONENT_SEP;
 	}
 
-	q--;			/* Back up last component separator */
-	*q++ = REALM_SEP;
+	if (i > 0) {
+		q--;			/* Back up last component separator */
+		*q++ = REALM_SEP;
+	}
 	
 	cp = krb5_princ_realm(context, principal)->data;
 	length = krb5_princ_realm(context, principal)->length;
